unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  StdCtrls, ExtCtrls, Grids,

  x,{$IFDEF LCLGTK} gtk, gdk, glib, {$ENDIF}
  {$IFDEF LCLGTK2} gtk2, gdk2, glib2, gdk2x, {$ENDIF}
  process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_getplaylist: TButton;
    Button_stop: TButton;
    Button_play: TButton;
    Button_pause: TButton;
    ComboBox_cashe: TComboBox;
    Edit_url: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label_out: TLabel;
    Memo1: TMemo;
    PageControl1: TPageControl;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel_video: TPanel;
    Panel_log: TPanel;
    ScrollBox1: TScrollBox;
    sg: TStringGrid;
    Splitter1: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    procedure Button_getplaylistClick(Sender: TObject);
    procedure Button_pauseClick(Sender: TObject);
    procedure Button_stopClick(Sender: TObject);
    procedure Button_playClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure get_wid(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1 : TForm1;
    xid : TWindow;		//X window handle
hWidget : THandle;	//the integrable widget
     pr : tprocess;
appname : string = 'Simple Filmix.net viewer (version 0.1 alfa)';
implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  pagecontrol1.activepageindex := 0;
  sg.ColWidths[0] := 200;
  get_wid(sender);
  pr:=TProcess.Create(nil);
  caption := appname;
end;


procedure TForm1.get_wid(Sender: TObject);
{$IFDEF LCLQT}
begin
  xid:= QWidget_winId(QWidgetH(AWidget));
  hWidget:= AWidget;
end;
{$ELSE}
var
   widget,
   mySocket:PGtkWidget;	//the socket
   lst:PGlist;
begin
  lst:=gtk_container_children(GTK_CONTAINER(PGtkwidget(panel_video.Handle)));
  if lst=nil then exit;
  widget := PGtkWidget(lst^.data);
  mySocket := gtk_socket_new();
  gtk_container_add (GTK_CONTAINER(widget), mySocket);

  gtk_widget_show(mySocket);
  gtk_widget_show(widget);

  //gtk_container_add (GTK_CONTAINER (PGtkWidget(Awidget)), widget);
  gtk_widget_realize(mySocket);
  //gtk_widget_hide(PGtkWidget(AWidget));
{$IFDEF LCLGTK}
  xid:=(PGdkWindowPrivate(widget^.window))^.xwindow;
{$ENDIF}
{$IFDEF LCLGTK2}
  xid:=GDK_WINDOW_XID(widget^.window);
{$ENDIF}
  hWidget:= THandle(widget);
end;
{$ENDIF}

procedure TForm1.Button_playClick(Sender: TObject);
var sl : tstringlist;
    s : string;
begin
  if pr.Running then
  begin
   Button_pauseClick(Sender);
   exit;
  end;

  if sg.RowCount < 1 then
  begin
   showmessage('Список пуст!');
   exit;
  end;

  Button_stopClick(Sender);
  pr.Options := Pr.Options + [poUsePipes, poNoConsole]; //mplayer stops if poUsePipes used.
  pr.CommandLine:='mplayer' + ' -cache ' + ComboBox_cashe.text + ' ' + sg.cells[1,sg.row] +' -wid '+IntToStr(xid);
  pr.Execute;

  sl := tstringlist.create;           //вывод pipes
  while pr.running do
    begin
     sl.loadfromstream(pr.output);
     if sl.count > 0 then
       begin
         s := sl[sl.count-1];
         //немного псевдоруссификации
         begin
         if pos('Playing',s) > 0 then
            begin
              delete(s,1,length('Playing'));
              s := 'Проигрываем ' + s;
            end;

         if pos('Resolving',s) > 0 then
            begin
              delete(s,1,length('Resolving'));
              s := 'Проверяем ' + s;
            end;

         if pos('Connecting to server',s) > 0 then
            begin
              delete(s,1,length('Connecting to server'));
              s := 'Подключаемся к серверу ' + s;
            end;

         if pos('Connected',s) > 0 then
            begin
              delete(s,1,length('Connected'));
              s := 'Подключились успешно. Начинаем прием потока ... ' + s;
            end;

         if pos('unknown object',s) > 0 then
            begin
              delete(s,1,length('unknown object'));
              s := 'Не известный объект ' + s;
            end;

         if pos('file object, packet length',s) > 0 then
            begin
              delete(s,1,length('file object, packet length'));
              s := 'Файловый объект, размер пакета ' + s;
            end;

         if pos('stream object, stream ID:',s) > 0 then
            begin
              delete(s,1,length('stream object, stream ID:'));
              s := 'Потоковый объект, ID: ' + s;
            end;

         if pos('data object',s) > 0 then
            begin
              delete(s,1,length('data object'));
              s := 'Объект данных ' + s;
            end;

         if pos('Cache size set to',s) > 0 then
            begin
              delete(s,1,length('Cache size set to'));
              s := 'Размер буфера: ' + s;
            end;

         if pos('Cache fill',s) > 0 then
            begin
              delete(s,1,length('Cache fill'));
              s := 'Буферизация ' + s;
            end;

         if pos ('Cache not filling!',s) > 0 then
            s := 'Кеш не достаточен';


         if pos('Exiting...',s) > 0 then
            begin
              delete(s,1,length('Exiting...'));
              s := 'Проигрывание прервано' + s;
            end;
         end;//руссификация
         Label_out.caption := s;
       end;

     application.processmessages;
    end;
   sl.free;

end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  Button_stopClick(Sender);
  pr.Free;
end;



procedure TForm1.Button_stopClick(Sender: TObject);
begin
  if pr.Running then
  begin
   pr.Terminate(0);
   panel_video.Repaint;
  end;
end;

procedure TForm1.Button_pauseClick(Sender: TObject);
const bufsize = 1024;
var Buf : Array[1..bufsize] of char;
begin
  buf := ' ';
  if Pr.Running then Pr.Input.Write(buf, length(buf));
end;

procedure TForm1.Button_getplaylistClick(Sender: TObject);
var p : tprocess;
    s : string;
    i : integer;
   sl : tstringlist;
begin
 sg.RowCount:= 1;
 Label_out.Caption:= 'Получаем файл со списком. Пожалуйста подождите ...';
 application.ProcessMessages;

 sl := tstringlist.create;

 p := TProcess.Create(nil);
 p.CommandLine := 'curl' + ' ' + edit_url.text;
 p.Options := p.Options + [pousepipes, poWaitOnExit];
 p.Execute;

 sl.LoadFromStream(p.output);
 Label_out.Caption:= 'Адрес файла со списком определен! Запрашиваем список ...';
 application.ProcessMessages;

 while (pos('function player1()', sl[0]) = 0) do sl.Delete(0);
 while (pos('</script>', sl[0]) = 0) do sl.Delete(0);

 while (pos('pl=http://filmix.net',sl[0]) = 0)
       and(pos('file=http://',sl[0]) = 0)
 do sl.Delete(0);

 s := sl[0];

 if pos('pl=http://filmix.net',sl[0]) <> 0 then
 begin
 delete(s,1,pos('pl=http://filmix.net',sl[0]) + 2);

 sl.Clear;
 s := copy(s,1,pos('.txt',s) + 3);

 Label_out.Caption:= 'Список получен, расшифровываем ...';
 application.ProcessMessages;

 p.CommandLine := 'curl' + ' ' + s;
 p.Execute;

 sl.LoadFromStream(p.output);

 for i := 0 to sl.Count - 1 do
   begin

     s := sl[i];
     delete(s,1,pos('":"',s) + 2);

     sg.RowCount:= sg.RowCount + 1;
     sg.Cells[0,sg.RowCount - 1] := copy(s,1,pos('"',s) - 1);
     delete(s,1,pos('":"',s) + 2);

     sg.Cells[1,sg.RowCount - 1] := copy(s,1,pos('"',s) - 1);

   end;
 end;

 if (pos('file=http://',sl[0]) <> 0) then     //if film
  begin
    delete(s,1,pos('file=http://',sl[0]) + 4);
    s := copy(s,1,pos('"',s) - 1);
    if s[length(s)] = '\' then delete(s,length(s),1);

    sg.RowCount:= sg.RowCount + 1;
    sg.Cells[0,sg.RowCount - 1] := extractfilename(s);
    sg.Cells[1,sg.RowCount - 1] := s;

  end;
 Label_out.Caption:= 'Готово. Приятного просмотра!';
 p.free;
 sl.free;
end;

end.

